// services/device/public/mojom/battery_status.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_DEVICE_PUBLIC_MOJOM_BATTERY_STATUS_MOJOM_H_
#define SERVICES_DEVICE_PUBLIC_MOJOM_BATTERY_STATUS_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "services/device/public/mojom/battery_status.mojom-shared.h"
#include "services/device/public/mojom/battery_status.mojom-forward.h"
#include <string>
#include <vector>







// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace device {
namespace mojom {





class  BatteryStatus {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<BatteryStatus, T>::value>;
  using DataView = BatteryStatusDataView;
  using Data_ = internal::BatteryStatus_Data;

  template <typename... Args>
  static BatteryStatusPtr New(Args&&... args) {
    return BatteryStatusPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static BatteryStatusPtr From(const U& u) {
    return mojo::TypeConverter<BatteryStatusPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, BatteryStatus>::Convert(*this);
  }


  BatteryStatus();

  BatteryStatus(
      bool charging,
      double charging_time,
      double discharging_time,
      double level);

  ~BatteryStatus();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = BatteryStatusPtr>
  BatteryStatusPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, BatteryStatus::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        BatteryStatus::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        BatteryStatus::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::BatteryStatus_UnserializedMessageContext<
            UserType, BatteryStatus::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<BatteryStatus::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return BatteryStatus::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::BatteryStatus_UnserializedMessageContext<
            UserType, BatteryStatus::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<BatteryStatus::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  bool charging;
  
  double charging_time;
  
  double discharging_time;
  
  double level;

  // Write this structure into |value|. The members are represented as a
  // dictionary |member name|: |member value|. This method does not deal with
  // the dictionary name. The caller is responsible for not calling
  // |AsValueInto| when |value| expects array items (see Array/Dictionary
  // methods of |base::trace_event::TracedValue|).
  //
  // |value| The TracedValue to be written into.
  //
  // Example uses:
  //
  //   // |my_var1, my_var2| are variables with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   value->BeginDictionary("my_var1");
  //   my_var1.AsValueInto(value.get());
  //   value->EndDictionary();
  //   value->BeginDictionary("my_var2");
  //   my_var2.AsValueInto(value.get());
  //   value->EndDictionary();
  //
  //   // |my_var| is a variable with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   my_var.AsValueInto(value.get());
  //   TRACE_EVENT1("test", "test", "my_var", std::move(value));
  //
  // Calling |AsValueInto| on two objects without opening and closing a
  // dictionary for each object is theoretically possible, but strongly
  // discouraged due to potential name collisions:
  //
  //   struct A {
  //     int foo;
  //   };
  //   struct B {
  //     int bar;
  //   };
  //   struct C {
  //     int foo;
  //     int bar;
  //   };
  //   auto value1 = std::make_unique<base::trace_event::TracedValue>();
  //   auto value2 = std::make_unique<base::trace_event::TracedValue>();
  //   A a;
  //   B b;
  //   C c;
  //   // value1 and value2 will be filled with the same information:
  //   a.AsValueInto(value1);
  //   b.AsValueInto(value1);
  //   c.AsValueInto(value2);
  void AsValueInto(base::trace_event::TracedValue* value) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, BatteryStatus::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, BatteryStatus::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, BatteryStatus::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, BatteryStatus::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}




template <typename StructPtrType>
BatteryStatusPtr BatteryStatus::Clone() const {
  return New(
      mojo::Clone(charging),
      mojo::Clone(charging_time),
      mojo::Clone(discharging_time),
      mojo::Clone(level)
  );
}

template <typename T, BatteryStatus::EnableIfSame<T>*>
bool BatteryStatus::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->charging, other_struct.charging))
    return false;
  if (!mojo::Equals(this->charging_time, other_struct.charging_time))
    return false;
  if (!mojo::Equals(this->discharging_time, other_struct.discharging_time))
    return false;
  if (!mojo::Equals(this->level, other_struct.level))
    return false;
  return true;
}

template <typename T, BatteryStatus::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<>{}(lhs.charging, rhs.charging))
    return true;
  if (std::less<>{}(rhs.charging, lhs.charging))
    return false;
  if (std::less<>{}(lhs.charging_time, rhs.charging_time))
    return true;
  if (std::less<>{}(rhs.charging_time, lhs.charging_time))
    return false;
  if (std::less<>{}(lhs.discharging_time, rhs.discharging_time))
    return true;
  if (std::less<>{}(rhs.discharging_time, lhs.discharging_time))
    return false;
  if (std::less<>{}(lhs.level, rhs.level))
    return true;
  if (std::less<>{}(rhs.level, lhs.level))
    return false;
  return false;
}


}  // namespace mojom
}  // namespace device

namespace mojo {


template <>
struct  StructTraits<::device::mojom::BatteryStatus::DataView,
                                         ::device::mojom::BatteryStatusPtr> {
  static bool IsNull(const ::device::mojom::BatteryStatusPtr& input) { return !input; }
  static void SetToNull(::device::mojom::BatteryStatusPtr* output) { output->reset(); }

  static decltype(::device::mojom::BatteryStatus::charging) charging(
      const ::device::mojom::BatteryStatusPtr& input) {
    return input->charging;
  }

  static decltype(::device::mojom::BatteryStatus::charging_time) charging_time(
      const ::device::mojom::BatteryStatusPtr& input) {
    return input->charging_time;
  }

  static decltype(::device::mojom::BatteryStatus::discharging_time) discharging_time(
      const ::device::mojom::BatteryStatusPtr& input) {
    return input->discharging_time;
  }

  static decltype(::device::mojom::BatteryStatus::level) level(
      const ::device::mojom::BatteryStatusPtr& input) {
    return input->level;
  }

  static bool Read(::device::mojom::BatteryStatus::DataView input, ::device::mojom::BatteryStatusPtr* output);
};

}  // namespace mojo

#endif  // SERVICES_DEVICE_PUBLIC_MOJOM_BATTERY_STATUS_MOJOM_H_