// services/viz/public/mojom/compositing/shared_quad_state.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_SHARED_QUAD_STATE_MOJOM_H_
#define SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_SHARED_QUAD_STATE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "services/viz/public/mojom/compositing/shared_quad_state.mojom-shared.h"
#include "services/viz/public/mojom/compositing/shared_quad_state.mojom-forward.h"
#include "ui/gfx/geometry/mojom/geometry.mojom.h"
#include "ui/gfx/mojom/rrect_f.mojom.h"
#include "ui/gfx/mojom/transform.mojom.h"
#include <string>
#include <vector>




#include "services/viz/public/cpp/compositing/shared_quad_state_mojom_traits.h"



// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace viz {
namespace mojom {








class  SharedQuadState {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<SharedQuadState, T>::value>;
  using DataView = SharedQuadStateDataView;
  using Data_ = internal::SharedQuadState_Data;

  template <typename... Args>
  static SharedQuadStatePtr New(Args&&... args) {
    return SharedQuadStatePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static SharedQuadStatePtr From(const U& u) {
    return mojo::TypeConverter<SharedQuadStatePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, SharedQuadState>::Convert(*this);
  }


  SharedQuadState();

  SharedQuadState(
      const ::gfx::Transform& quad_to_target_transform,
      const ::gfx::Rect& quad_layer_rect,
      const ::gfx::Rect& visible_quad_layer_rect,
      const ::gfx::RRectF& rounded_corner_bounds,
      const ::gfx::Rect& clip_rect,
      bool is_clipped,
      bool are_contents_opaque,
      float opacity,
      uint32_t blend_mode,
      int32_t sorting_context_id,
      bool is_fast_rounded_corner,
      float de_jelly_delta_y,
      bool no_damage);

  ~SharedQuadState();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = SharedQuadStatePtr>
  SharedQuadStatePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, SharedQuadState::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        SharedQuadState::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        SharedQuadState::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::SharedQuadState_UnserializedMessageContext<
            UserType, SharedQuadState::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<SharedQuadState::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return SharedQuadState::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::SharedQuadState_UnserializedMessageContext<
            UserType, SharedQuadState::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<SharedQuadState::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  ::gfx::Transform quad_to_target_transform;
  
  ::gfx::Rect quad_layer_rect;
  
  ::gfx::Rect visible_quad_layer_rect;
  
  ::gfx::RRectF rounded_corner_bounds;
  
  ::gfx::Rect clip_rect;
  
  bool is_clipped;
  
  bool are_contents_opaque;
  
  float opacity;
  
  uint32_t blend_mode;
  
  int32_t sorting_context_id;
  
  bool is_fast_rounded_corner;
  
  float de_jelly_delta_y;
  
  bool no_damage;

  // Write this structure into |value|. The members are represented as a
  // dictionary |member name|: |member value|. This method does not deal with
  // the dictionary name. The caller is responsible for not calling
  // |AsValueInto| when |value| expects array items (see Array/Dictionary
  // methods of |base::trace_event::TracedValue|).
  //
  // |value| The TracedValue to be written into.
  //
  // Example uses:
  //
  //   // |my_var1, my_var2| are variables with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   value->BeginDictionary("my_var1");
  //   my_var1.AsValueInto(value.get());
  //   value->EndDictionary();
  //   value->BeginDictionary("my_var2");
  //   my_var2.AsValueInto(value.get());
  //   value->EndDictionary();
  //
  //   // |my_var| is a variable with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   my_var.AsValueInto(value.get());
  //   TRACE_EVENT1("test", "test", "my_var", std::move(value));
  //
  // Calling |AsValueInto| on two objects without opening and closing a
  // dictionary for each object is theoretically possible, but strongly
  // discouraged due to potential name collisions:
  //
  //   struct A {
  //     int foo;
  //   };
  //   struct B {
  //     int bar;
  //   };
  //   struct C {
  //     int foo;
  //     int bar;
  //   };
  //   auto value1 = std::make_unique<base::trace_event::TracedValue>();
  //   auto value2 = std::make_unique<base::trace_event::TracedValue>();
  //   A a;
  //   B b;
  //   C c;
  //   // value1 and value2 will be filled with the same information:
  //   a.AsValueInto(value1);
  //   b.AsValueInto(value1);
  //   c.AsValueInto(value2);
  void AsValueInto(base::trace_event::TracedValue* value) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, SharedQuadState::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, SharedQuadState::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, SharedQuadState::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, SharedQuadState::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
SharedQuadStatePtr SharedQuadState::Clone() const {
  return New(
      mojo::Clone(quad_to_target_transform),
      mojo::Clone(quad_layer_rect),
      mojo::Clone(visible_quad_layer_rect),
      mojo::Clone(rounded_corner_bounds),
      mojo::Clone(clip_rect),
      mojo::Clone(is_clipped),
      mojo::Clone(are_contents_opaque),
      mojo::Clone(opacity),
      mojo::Clone(blend_mode),
      mojo::Clone(sorting_context_id),
      mojo::Clone(is_fast_rounded_corner),
      mojo::Clone(de_jelly_delta_y),
      mojo::Clone(no_damage)
  );
}

template <typename T, SharedQuadState::EnableIfSame<T>*>
bool SharedQuadState::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->quad_to_target_transform, other_struct.quad_to_target_transform))
    return false;
  if (!mojo::Equals(this->quad_layer_rect, other_struct.quad_layer_rect))
    return false;
  if (!mojo::Equals(this->visible_quad_layer_rect, other_struct.visible_quad_layer_rect))
    return false;
  if (!mojo::Equals(this->rounded_corner_bounds, other_struct.rounded_corner_bounds))
    return false;
  if (!mojo::Equals(this->clip_rect, other_struct.clip_rect))
    return false;
  if (!mojo::Equals(this->is_clipped, other_struct.is_clipped))
    return false;
  if (!mojo::Equals(this->are_contents_opaque, other_struct.are_contents_opaque))
    return false;
  if (!mojo::Equals(this->opacity, other_struct.opacity))
    return false;
  if (!mojo::Equals(this->blend_mode, other_struct.blend_mode))
    return false;
  if (!mojo::Equals(this->sorting_context_id, other_struct.sorting_context_id))
    return false;
  if (!mojo::Equals(this->is_fast_rounded_corner, other_struct.is_fast_rounded_corner))
    return false;
  if (!mojo::Equals(this->de_jelly_delta_y, other_struct.de_jelly_delta_y))
    return false;
  if (!mojo::Equals(this->no_damage, other_struct.no_damage))
    return false;
  return true;
}

template <typename T, SharedQuadState::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<>{}(lhs.quad_to_target_transform, rhs.quad_to_target_transform))
    return true;
  if (std::less<>{}(rhs.quad_to_target_transform, lhs.quad_to_target_transform))
    return false;
  if (std::less<>{}(lhs.quad_layer_rect, rhs.quad_layer_rect))
    return true;
  if (std::less<>{}(rhs.quad_layer_rect, lhs.quad_layer_rect))
    return false;
  if (std::less<>{}(lhs.visible_quad_layer_rect, rhs.visible_quad_layer_rect))
    return true;
  if (std::less<>{}(rhs.visible_quad_layer_rect, lhs.visible_quad_layer_rect))
    return false;
  if (std::less<>{}(lhs.rounded_corner_bounds, rhs.rounded_corner_bounds))
    return true;
  if (std::less<>{}(rhs.rounded_corner_bounds, lhs.rounded_corner_bounds))
    return false;
  if (std::less<>{}(lhs.clip_rect, rhs.clip_rect))
    return true;
  if (std::less<>{}(rhs.clip_rect, lhs.clip_rect))
    return false;
  if (std::less<>{}(lhs.is_clipped, rhs.is_clipped))
    return true;
  if (std::less<>{}(rhs.is_clipped, lhs.is_clipped))
    return false;
  if (std::less<>{}(lhs.are_contents_opaque, rhs.are_contents_opaque))
    return true;
  if (std::less<>{}(rhs.are_contents_opaque, lhs.are_contents_opaque))
    return false;
  if (std::less<>{}(lhs.opacity, rhs.opacity))
    return true;
  if (std::less<>{}(rhs.opacity, lhs.opacity))
    return false;
  if (std::less<>{}(lhs.blend_mode, rhs.blend_mode))
    return true;
  if (std::less<>{}(rhs.blend_mode, lhs.blend_mode))
    return false;
  if (std::less<>{}(lhs.sorting_context_id, rhs.sorting_context_id))
    return true;
  if (std::less<>{}(rhs.sorting_context_id, lhs.sorting_context_id))
    return false;
  if (std::less<>{}(lhs.is_fast_rounded_corner, rhs.is_fast_rounded_corner))
    return true;
  if (std::less<>{}(rhs.is_fast_rounded_corner, lhs.is_fast_rounded_corner))
    return false;
  if (std::less<>{}(lhs.de_jelly_delta_y, rhs.de_jelly_delta_y))
    return true;
  if (std::less<>{}(rhs.de_jelly_delta_y, lhs.de_jelly_delta_y))
    return false;
  if (std::less<>{}(lhs.no_damage, rhs.no_damage))
    return true;
  if (std::less<>{}(rhs.no_damage, lhs.no_damage))
    return false;
  return false;
}


}  // namespace mojom
}  // namespace viz

namespace mojo {


template <>
struct  StructTraits<::viz::mojom::SharedQuadState::DataView,
                                         ::viz::mojom::SharedQuadStatePtr> {
  static bool IsNull(const ::viz::mojom::SharedQuadStatePtr& input) { return !input; }
  static void SetToNull(::viz::mojom::SharedQuadStatePtr* output) { output->reset(); }

  static const decltype(::viz::mojom::SharedQuadState::quad_to_target_transform)& quad_to_target_transform(
      const ::viz::mojom::SharedQuadStatePtr& input) {
    return input->quad_to_target_transform;
  }

  static const decltype(::viz::mojom::SharedQuadState::quad_layer_rect)& quad_layer_rect(
      const ::viz::mojom::SharedQuadStatePtr& input) {
    return input->quad_layer_rect;
  }

  static const decltype(::viz::mojom::SharedQuadState::visible_quad_layer_rect)& visible_quad_layer_rect(
      const ::viz::mojom::SharedQuadStatePtr& input) {
    return input->visible_quad_layer_rect;
  }

  static const decltype(::viz::mojom::SharedQuadState::rounded_corner_bounds)& rounded_corner_bounds(
      const ::viz::mojom::SharedQuadStatePtr& input) {
    return input->rounded_corner_bounds;
  }

  static const decltype(::viz::mojom::SharedQuadState::clip_rect)& clip_rect(
      const ::viz::mojom::SharedQuadStatePtr& input) {
    return input->clip_rect;
  }

  static decltype(::viz::mojom::SharedQuadState::is_clipped) is_clipped(
      const ::viz::mojom::SharedQuadStatePtr& input) {
    return input->is_clipped;
  }

  static decltype(::viz::mojom::SharedQuadState::are_contents_opaque) are_contents_opaque(
      const ::viz::mojom::SharedQuadStatePtr& input) {
    return input->are_contents_opaque;
  }

  static decltype(::viz::mojom::SharedQuadState::opacity) opacity(
      const ::viz::mojom::SharedQuadStatePtr& input) {
    return input->opacity;
  }

  static decltype(::viz::mojom::SharedQuadState::blend_mode) blend_mode(
      const ::viz::mojom::SharedQuadStatePtr& input) {
    return input->blend_mode;
  }

  static decltype(::viz::mojom::SharedQuadState::sorting_context_id) sorting_context_id(
      const ::viz::mojom::SharedQuadStatePtr& input) {
    return input->sorting_context_id;
  }

  static decltype(::viz::mojom::SharedQuadState::is_fast_rounded_corner) is_fast_rounded_corner(
      const ::viz::mojom::SharedQuadStatePtr& input) {
    return input->is_fast_rounded_corner;
  }

  static decltype(::viz::mojom::SharedQuadState::de_jelly_delta_y) de_jelly_delta_y(
      const ::viz::mojom::SharedQuadStatePtr& input) {
    return input->de_jelly_delta_y;
  }

  static decltype(::viz::mojom::SharedQuadState::no_damage) no_damage(
      const ::viz::mojom::SharedQuadStatePtr& input) {
    return input->no_damage;
  }

  static bool Read(::viz::mojom::SharedQuadState::DataView input, ::viz::mojom::SharedQuadStatePtr* output);
};

}  // namespace mojo

#endif  // SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_SHARED_QUAD_STATE_MOJOM_H_