// services/viz/public/mojom/hit_test/aggregated_hit_test_region.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIZ_PUBLIC_MOJOM_HIT_TEST_AGGREGATED_HIT_TEST_REGION_MOJOM_BLINK_H_
#define SERVICES_VIZ_PUBLIC_MOJOM_HIT_TEST_AGGREGATED_HIT_TEST_REGION_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "services/viz/public/mojom/hit_test/aggregated_hit_test_region.mojom-shared.h"
#include "services/viz/public/mojom/hit_test/aggregated_hit_test_region.mojom-blink-forward.h"
#include "services/viz/public/mojom/compositing/frame_sink_id.mojom-blink.h"
#include "ui/gfx/geometry/mojom/geometry.mojom-blink.h"
#include "ui/gfx/mojom/transform.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"




#include "third_party/blink/public/platform/web_common.h"



// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace viz {
namespace mojom {
namespace blink {








class BLINK_PLATFORM_EXPORT AggregatedHitTestRegion {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AggregatedHitTestRegion, T>::value>;
  using DataView = AggregatedHitTestRegionDataView;
  using Data_ = internal::AggregatedHitTestRegion_Data;

  template <typename... Args>
  static AggregatedHitTestRegionPtr New(Args&&... args) {
    return AggregatedHitTestRegionPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AggregatedHitTestRegionPtr From(const U& u) {
    return mojo::TypeConverter<AggregatedHitTestRegionPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AggregatedHitTestRegion>::Convert(*this);
  }


  AggregatedHitTestRegion();

  AggregatedHitTestRegion(
      const ::viz::FrameSinkId& frame_sink_id,
      uint32_t flags,
      uint32_t async_hit_test_reasons,
      const ::gfx::Rect& rect,
      uint32_t child_count,
      const ::gfx::Transform& transform);

  ~AggregatedHitTestRegion();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AggregatedHitTestRegionPtr>
  AggregatedHitTestRegionPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AggregatedHitTestRegion::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AggregatedHitTestRegion::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AggregatedHitTestRegion::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AggregatedHitTestRegion_UnserializedMessageContext<
            UserType, AggregatedHitTestRegion::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<AggregatedHitTestRegion::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return AggregatedHitTestRegion::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AggregatedHitTestRegion_UnserializedMessageContext<
            UserType, AggregatedHitTestRegion::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AggregatedHitTestRegion::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  ::viz::FrameSinkId frame_sink_id;
  
  uint32_t flags;
  
  uint32_t async_hit_test_reasons;
  
  ::gfx::Rect rect;
  
  uint32_t child_count;
  
  ::gfx::Transform transform;

  // Write this structure into |value|. The members are represented as a
  // dictionary |member name|: |member value|. This method does not deal with
  // the dictionary name. The caller is responsible for not calling
  // |AsValueInto| when |value| expects array items (see Array/Dictionary
  // methods of |base::trace_event::TracedValue|).
  //
  // |value| The TracedValue to be written into.
  //
  // Example uses:
  //
  //   // |my_var1, my_var2| are variables with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   value->BeginDictionary("my_var1");
  //   my_var1.AsValueInto(value.get());
  //   value->EndDictionary();
  //   value->BeginDictionary("my_var2");
  //   my_var2.AsValueInto(value.get());
  //   value->EndDictionary();
  //
  //   // |my_var| is a variable with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   my_var.AsValueInto(value.get());
  //   TRACE_EVENT1("test", "test", "my_var", std::move(value));
  //
  // Calling |AsValueInto| on two objects without opening and closing a
  // dictionary for each object is theoretically possible, but strongly
  // discouraged due to potential name collisions:
  //
  //   struct A {
  //     int foo;
  //   };
  //   struct B {
  //     int bar;
  //   };
  //   struct C {
  //     int foo;
  //     int bar;
  //   };
  //   auto value1 = std::make_unique<base::trace_event::TracedValue>();
  //   auto value2 = std::make_unique<base::trace_event::TracedValue>();
  //   A a;
  //   B b;
  //   C c;
  //   // value1 and value2 will be filled with the same information:
  //   a.AsValueInto(value1);
  //   b.AsValueInto(value1);
  //   c.AsValueInto(value2);
  void AsValueInto(base::trace_event::TracedValue* value) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AggregatedHitTestRegion::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AggregatedHitTestRegion::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AggregatedHitTestRegion::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AggregatedHitTestRegion::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
AggregatedHitTestRegionPtr AggregatedHitTestRegion::Clone() const {
  return New(
      mojo::Clone(frame_sink_id),
      mojo::Clone(flags),
      mojo::Clone(async_hit_test_reasons),
      mojo::Clone(rect),
      mojo::Clone(child_count),
      mojo::Clone(transform)
  );
}

template <typename T, AggregatedHitTestRegion::EnableIfSame<T>*>
bool AggregatedHitTestRegion::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->frame_sink_id, other_struct.frame_sink_id))
    return false;
  if (!mojo::Equals(this->flags, other_struct.flags))
    return false;
  if (!mojo::Equals(this->async_hit_test_reasons, other_struct.async_hit_test_reasons))
    return false;
  if (!mojo::Equals(this->rect, other_struct.rect))
    return false;
  if (!mojo::Equals(this->child_count, other_struct.child_count))
    return false;
  if (!mojo::Equals(this->transform, other_struct.transform))
    return false;
  return true;
}

template <typename T, AggregatedHitTestRegion::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<>{}(lhs.frame_sink_id, rhs.frame_sink_id))
    return true;
  if (std::less<>{}(rhs.frame_sink_id, lhs.frame_sink_id))
    return false;
  if (std::less<>{}(lhs.flags, rhs.flags))
    return true;
  if (std::less<>{}(rhs.flags, lhs.flags))
    return false;
  if (std::less<>{}(lhs.async_hit_test_reasons, rhs.async_hit_test_reasons))
    return true;
  if (std::less<>{}(rhs.async_hit_test_reasons, lhs.async_hit_test_reasons))
    return false;
  if (std::less<>{}(lhs.rect, rhs.rect))
    return true;
  if (std::less<>{}(rhs.rect, lhs.rect))
    return false;
  if (std::less<>{}(lhs.child_count, rhs.child_count))
    return true;
  if (std::less<>{}(rhs.child_count, lhs.child_count))
    return false;
  if (std::less<>{}(lhs.transform, rhs.transform))
    return true;
  if (std::less<>{}(rhs.transform, lhs.transform))
    return false;
  return false;
}


}  // namespace blink
}  // namespace mojom
}  // namespace viz

namespace mojo {


template <>
struct BLINK_PLATFORM_EXPORT StructTraits<::viz::mojom::blink::AggregatedHitTestRegion::DataView,
                                         ::viz::mojom::blink::AggregatedHitTestRegionPtr> {
  static bool IsNull(const ::viz::mojom::blink::AggregatedHitTestRegionPtr& input) { return !input; }
  static void SetToNull(::viz::mojom::blink::AggregatedHitTestRegionPtr* output) { output->reset(); }

  static const decltype(::viz::mojom::blink::AggregatedHitTestRegion::frame_sink_id)& frame_sink_id(
      const ::viz::mojom::blink::AggregatedHitTestRegionPtr& input) {
    return input->frame_sink_id;
  }

  static decltype(::viz::mojom::blink::AggregatedHitTestRegion::flags) flags(
      const ::viz::mojom::blink::AggregatedHitTestRegionPtr& input) {
    return input->flags;
  }

  static decltype(::viz::mojom::blink::AggregatedHitTestRegion::async_hit_test_reasons) async_hit_test_reasons(
      const ::viz::mojom::blink::AggregatedHitTestRegionPtr& input) {
    return input->async_hit_test_reasons;
  }

  static const decltype(::viz::mojom::blink::AggregatedHitTestRegion::rect)& rect(
      const ::viz::mojom::blink::AggregatedHitTestRegionPtr& input) {
    return input->rect;
  }

  static decltype(::viz::mojom::blink::AggregatedHitTestRegion::child_count) child_count(
      const ::viz::mojom::blink::AggregatedHitTestRegionPtr& input) {
    return input->child_count;
  }

  static const decltype(::viz::mojom::blink::AggregatedHitTestRegion::transform)& transform(
      const ::viz::mojom::blink::AggregatedHitTestRegionPtr& input) {
    return input->transform;
  }

  static bool Read(::viz::mojom::blink::AggregatedHitTestRegion::DataView input, ::viz::mojom::blink::AggregatedHitTestRegionPtr* output);
};

}  // namespace mojo

#endif  // SERVICES_VIZ_PUBLIC_MOJOM_HIT_TEST_AGGREGATED_HIT_TEST_REGION_MOJOM_BLINK_H_