// third_party/blink/public/mojom/permissions/permission_automation.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_PERMISSIONS_PERMISSION_AUTOMATION_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_PERMISSIONS_PERMISSION_AUTOMATION_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/blink/public/mojom/permissions/permission_automation.mojom-shared.h"
#include "third_party/blink/public/mojom/permissions/permission_automation.mojom-forward.h"
#include "third_party/blink/public/mojom/permissions/permission.mojom.h"
#include "third_party/blink/public/mojom/permissions/permission_status.mojom-forward.h"
#include "url/mojom/url.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"


#include "third_party/blink/public/common/common_export.h"



// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace blink {
namespace test {
namespace mojom {

class PermissionAutomationProxy;

template <typename ImplRefTraits>
class PermissionAutomationStub;

class PermissionAutomationRequestValidator;
class PermissionAutomationResponseValidator;


class BLINK_COMMON_EXPORT PermissionAutomation
    : public PermissionAutomationInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = PermissionAutomationInterfaceBase;
  using Proxy_ = PermissionAutomationProxy;

  template <typename ImplRefTraits>
  using Stub_ = PermissionAutomationStub<ImplRefTraits>;

  using RequestValidator_ = PermissionAutomationRequestValidator;
  using ResponseValidator_ = PermissionAutomationResponseValidator;
  enum MethodMinVersions : uint32_t {
    kSetPermissionMinVersion = 0,
  };
  virtual ~PermissionAutomation() {}


  using SetPermissionCallback = base::OnceCallback<void(bool)>;
  
  virtual void SetPermission(::blink::mojom::PermissionDescriptorPtr descriptor, ::blink::mojom::PermissionStatus status, const ::GURL& origin, const ::GURL& embedding_origin, SetPermissionCallback callback) = 0;
};



class BLINK_COMMON_EXPORT PermissionAutomationProxy
    : public PermissionAutomation {
 public:
  using InterfaceType = PermissionAutomation;

  explicit PermissionAutomationProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void SetPermission(::blink::mojom::PermissionDescriptorPtr descriptor, ::blink::mojom::PermissionStatus status, const ::GURL& origin, const ::GURL& embedding_origin, SetPermissionCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT PermissionAutomationStubDispatch {
 public:
  static bool Accept(PermissionAutomation* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      PermissionAutomation* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<PermissionAutomation>>
class PermissionAutomationStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  PermissionAutomationStub() {}
  ~PermissionAutomationStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PermissionAutomationStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PermissionAutomationStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT PermissionAutomationRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT PermissionAutomationResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace test
}  // namespace blink

namespace mojo {

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_PERMISSIONS_PERMISSION_AUTOMATION_MOJOM_H_